Index: trunk/src/VBox/Frontends/VirtualBox/include/VBoxUtils.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/include/VBoxUtils.h	(revision 2574)
+++ trunk/src/VBox/Frontends/VirtualBox/include/VBoxUtils.h	(revision 2578)
@@ -28,4 +28,5 @@
 #include <qlistview.h>
 #include <qtextedit.h>
+#include <qlabel.h>
 
 /**
@@ -127,5 +128,5 @@
 };
 
-/** 
+/**
  *  Watches the given widget and makes sure the minimum widget size set by the layout
  *  manager does never get smaller than the previous minimum size set by the
@@ -133,5 +134,5 @@
  *  toggle buttons) will be able only to grow, never shrink, to avoid flicker
  *  during alternate contents updates (Pause -> Resume -> Pause -> ...).
- * 
+ *
  *  @todo not finished
  */
@@ -169,5 +170,5 @@
 
 
-/** 
+/**
  *  Simple QTextEdit subclass to return its minimumSizeHint() as sizeHint()
  *  for getting more compact layout.
@@ -175,4 +176,6 @@
 class QITextEdit : public QTextEdit
 {
+    Q_OBJECT
+
 public:
 
@@ -187,9 +190,60 @@
     QSize minimumSizeHint() const
     {
-        /// @todo (r=dmik) this looks a bit meanignless. any comment?
-        int w = 0;
-        int h = heightForWidth (w);
-        return QSize (w, h);
-    }
+        return QSize (width(), heightForWidth (width()));
+    }
+};
+
+
+/**
+ *  Simple QLabel subclass to re-query and return its sizeHint()
+ *  before the widget to be shown for getting more compact layout.
+ */
+class QILabel : public QLabel
+{
+    Q_OBJECT
+
+public:
+
+    QILabel (QWidget *aParent, const char *aName)
+         : QLabel (aParent, aName), mSizeHint (-1, -1)
+    {
+        /* setup default size policy and alignment */
+        setSizePolicy (QSizePolicy ((QSizePolicy::SizeType)1,
+                                    (QSizePolicy::SizeType)0,
+                                    0, 0,
+                                    sizePolicy().hasHeightForWidth()));
+        setAlignment (int (QLabel::WordBreak | QLabel::AlignTop));
+        /* install show-parent-widget watcher */
+        aParent->installEventFilter (this);
+    }
+
+    QSize sizeHint() const
+    {
+        /* use cashed sizeHint if mSizeHint is valid */
+        if (!mSizeHint.isValid())
+            mSizeHint = QLabel::sizeHint();
+        return mSizeHint;
+    }
+
+private:
+
+    bool eventFilter (QObject *aObject, QEvent *aEvent)
+    {
+        switch (aEvent->type())
+        {
+            case QEvent::Show:
+            {
+                /* watch for parent's show-event to recalculate sizeHint */
+                mSizeHint = QSize (width(), heightForWidth (width()));
+                updateGeometry();
+                break;
+            }
+            default:
+                break;
+        }
+        return QLabel::eventFilter (aObject, aEvent);
+    }
+
+    mutable QSize mSizeHint;
 };
 
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxNewHDWzd.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxNewHDWzd.ui	(revision 2574)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxNewHDWzd.ui	(revision 2578)
@@ -86,25 +86,4 @@
                         <cstring>unnamed</cstring>
                     </property>
-                    <widget class="QLabel">
-                        <property name="name">
-                            <cstring>txWelcome</cstring>
-                        </property>
-                        <property name="sizePolicy">
-                            <sizepolicy>
-                                <hsizetype>1</hsizetype>
-                                <vsizetype>0</vsizetype>
-                                <horstretch>0</horstretch>
-                                <verstretch>0</verstretch>
-                            </sizepolicy>
-                        </property>
-                        <property name="text">
-                            <string>&lt;p&gt;This wizard will help you to create a new virtual hard disk image for your virtual machine.&lt;/p&gt;
-&lt;p&gt;Use the &lt;b&gt;Next&lt;/b&gt; button to go to the next page of the wizard
-and the &lt;b&gt;Back&lt;/b&gt; button to return to the previous page.&lt;/p&gt;</string>
-                        </property>
-                        <property name="alignment">
-                            <set>WordBreak|AlignTop</set>
-                        </property>
-                    </widget>
                     <spacer>
                         <property name="name">
@@ -192,28 +171,4 @@
                         <number>10</number>
                     </property>
-                    <widget class="QLabel">
-                        <property name="name">
-                            <cstring>textLabel1_2</cstring>
-                        </property>
-                        <property name="sizePolicy">
-                            <sizepolicy>
-                                <hsizetype>1</hsizetype>
-                                <vsizetype>0</vsizetype>
-                                <horstretch>0</horstretch>
-                                <verstretch>0</verstretch>
-                            </sizepolicy>
-                        </property>
-                        <property name="text">
-                            <string>&lt;p&gt;Select the type of virtual hard disk image you want to create.&lt;/p&gt;
-&lt;p&gt;A &lt;b&gt;dynamically expanding image&lt;/b&gt; initially occupies a very small amount
-of space on your physical hard disk. It will grow dynamically (up to
-the size specified) as the Guest OS claims disk space.&lt;/p&gt;
-&lt;p&gt;A &lt;b&gt;fixed-size image&lt;/b&gt; does not grow. It is stored in a file of approximately
-the same size as the size of the virtual hard disk.&lt;/p&gt;</string>
-                        </property>
-                        <property name="alignment">
-                            <set>WordBreak|AlignTop</set>
-                        </property>
-                    </widget>
                     <widget class="QButtonGroup">
                         <property name="name">
@@ -322,24 +277,4 @@
                         <number>10</number>
                     </property>
-                    <widget class="QLabel">
-                        <property name="name">
-                            <cstring>txNameComment</cstring>
-                        </property>
-                        <property name="sizePolicy">
-                            <sizepolicy>
-                                <hsizetype>1</hsizetype>
-                                <vsizetype>0</vsizetype>
-                                <horstretch>0</horstretch>
-                                <verstretch>0</verstretch>
-                            </sizepolicy>
-                        </property>
-                        <property name="text">
-                            <string>&lt;p&gt;Press the &lt;b&gt;Select&lt;/b&gt; button to select the location and name of the file
-to store the virtual hard disk image or type a file name in the entry field.&lt;/p&gt;</string>
-                        </property>
-                        <property name="alignment">
-                            <set>WordBreak|AlignTop</set>
-                        </property>
-                    </widget>
                     <widget class="QGroupBox">
                         <property name="name">
@@ -385,24 +320,4 @@
                             </widget>
                         </hbox>
-                    </widget>
-                    <widget class="QLabel">
-                        <property name="name">
-                            <cstring>txSizeComment</cstring>
-                        </property>
-                        <property name="sizePolicy">
-                            <sizepolicy>
-                                <hsizetype>1</hsizetype>
-                                <vsizetype>0</vsizetype>
-                                <horstretch>0</horstretch>
-                                <verstretch>0</verstretch>
-                            </sizepolicy>
-                        </property>
-                        <property name="text">
-                            <string>&lt;p&gt;Select the size of the virtual hard disk image in megabytes. This size will be reported to the Guest OS
-as the size of the virtual hard disk.&lt;/p&gt;</string>
-                        </property>
-                        <property name="alignment">
-                            <set>WordBreak|AlignTop</set>
-                        </property>
                     </widget>
                     <widget class="QGroupBox">
@@ -475,5 +390,5 @@
                                                 </property>
                                                 <property name="alignment">
-                                                    <set>WordBreak|AlignVCenter|AlignLeft</set>
+                                                    <set>AlignVCenter|AlignLeft</set>
                                                 </property>
                                             </widget>
@@ -500,5 +415,5 @@
                                                 </property>
                                                 <property name="alignment">
-                                                    <set>WordBreak|AlignVCenter|AlignRight</set>
+                                                    <set>AlignVCenter|AlignRight</set>
                                                 </property>
                                             </widget>
@@ -617,44 +532,4 @@
                         <number>15</number>
                     </property>
-                    <widget class="QLabel">
-                        <property name="name">
-                            <cstring>txSummaryHdr</cstring>
-                        </property>
-                        <property name="sizePolicy">
-                            <sizepolicy>
-                                <hsizetype>1</hsizetype>
-                                <vsizetype>0</vsizetype>
-                                <horstretch>0</horstretch>
-                                <verstretch>0</verstretch>
-                            </sizepolicy>
-                        </property>
-                        <property name="text">
-                            <string>You are going to create a new virtual hard disk image with the following parameters:</string>
-                        </property>
-                        <property name="alignment">
-                            <set>WordBreak|AlignTop</set>
-                        </property>
-                    </widget>
-                    <widget class="QLabel">
-                        <property name="name">
-                            <cstring>txSummaryFtr</cstring>
-                        </property>
-                        <property name="sizePolicy">
-                            <sizepolicy>
-                                <hsizetype>1</hsizetype>
-                                <vsizetype>0</vsizetype>
-                                <horstretch>0</horstretch>
-                                <verstretch>0</verstretch>
-                            </sizepolicy>
-                        </property>
-                        <property name="text">
-                            <string>If the above settings are correct, press the &lt;b&gt;Finish&lt;/b&gt; button.
-                            Once you press it, a new hard disk image will be created.
-                            </string>
-                        </property>
-                        <property name="alignment">
-                            <set>WordBreak|AlignTop</set>
-                        </property>
-                    </widget>
                     <spacer>
                         <property name="name">
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxNewHDWzd.ui.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxNewHDWzd.ui.h	(revision 2574)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxNewHDWzd.ui.h	(revision 2578)
@@ -157,4 +157,55 @@
 void VBoxNewHDWzd::init()
 {
+    /* Wizard labels recreation */
+
+    QILabel *txWelcome = new QILabel (pageWelcome, "txWelcome");
+    txWelcome->setText (tr ("<p>This wizard will help you to create a new "
+                            "virtual hard disk image for your virtual "
+                            "machine.</p>\n""<p>Use the <b>Next</b> button to "
+                            "go to the next page of the wizard\n""and the "
+                            "<b>Back</b> button to return to the previous "
+                            "page.</p>"));
+    layout33->insertWidget (0, txWelcome);
+
+    QILabel *textLabel1_2 = new QILabel (pageType, "textLabel1_2");
+    textLabel1_2->setText (tr ("<p>Select the type of virtual hard disk image "
+                               "you want to create.</p>\n""<p>A "
+                               "<b>dynamically expanding image</b> initially "
+                               "occupies a very small amount\n""of space on "
+                               "your physical hard disk. It will grow "
+                               "dynamically (up to\n""the size specified) as "
+                               "the Guest OS claims disk space.</p>\n""<p>A "
+                               "<b>fixed-size image</b> does not grow. It is "
+                               "stored in a file of approximately\n""the same "
+                               "size as the size of the virtual hard "
+                               "disk.</p>"));
+    layout12->insertWidget (0, textLabel1_2);
+
+    QILabel *txNameComment = new QILabel (pageNameAndSize, "txNameComment");
+    txNameComment->setText (tr ("<p>Press the <b>Select</b> button to select "
+                                "the location and name of the file\n""to "
+                                "store the virtual hard disk image or type a "
+                                "file name in the entry field.</p>"));
+    layout36->insertWidget (0, txNameComment);
+
+    QILabel *txSizeComment = new QILabel (pageNameAndSize, "txSizeComment" );
+    txSizeComment->setText (tr ("<p>Select the size of the virtual hard disk "
+                                "image in megabytes. This size will be "
+                                "reported to the Guest OS\n""as the size of "
+                                "the virtual hard disk.</p>"));
+    layout36->insertWidget (2, txSizeComment);
+
+    QILabel *txSummaryHdr = new QILabel (pageSummary, "txSummaryHdr");
+    txSummaryHdr->setText (tr ("You are going to create a new virtual hard "
+                               "disk image with the following parameters:"));
+    summaryLayout->insertWidget (0, txSummaryHdr);
+
+    QILabel *txSummaryFtr = new QILabel (pageSummary, "txSummaryFtr");
+    txSummaryFtr->setText (tr ("If the above settings are correct, press the "
+                               "<b>Finish</b> button.\n"
+                               "                            Once you press "
+                               "it, a new hard disk image will be created.\n"
+                               "                            "));
+
     /* disable help buttons */
     helpButton()->setShown (false);
@@ -221,4 +272,5 @@
     teSummary->setReadOnly (TRUE);
     summaryLayout->insertWidget (1, teSummary);
+    summaryLayout->insertWidget (2, txSummaryFtr);
 
     /* filter out Enter keys in order to direct them to the default dlg button */
@@ -263,13 +315,4 @@
     /* the finish button on the Summary page is always enabled */
     setFinishEnabled (pageSummary, true);
-
-    /* setup minimum width for the sizeHint to be calculated correctly */
-    int wid = widthSpacer->minimumSize().width();
-    txWelcome->setMinimumWidth (wid);
-    textLabel1_2->setMinimumWidth (wid);
-    txNameComment->setMinimumWidth (wid);
-    txSizeComment->setMinimumWidth (wid);
-    txSummaryHdr->setMinimumWidth (wid);
-    txSummaryFtr->setMinimumWidth (wid);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxNewVMWzd.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxNewVMWzd.ui	(revision 2574)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxNewVMWzd.ui	(revision 2578)
@@ -84,26 +84,4 @@
                         <cstring>unnamed</cstring>
                     </property>
-                    <widget class="QLabel">
-                        <property name="name">
-                            <cstring>txWelcome</cstring>
-                        </property>
-                        <property name="sizePolicy">
-                            <sizepolicy>
-                                <hsizetype>1</hsizetype>
-                                <vsizetype>0</vsizetype>
-                                <horstretch>0</horstretch>
-                                <verstretch>0</verstretch>
-                            </sizepolicy>
-                        </property>
-                        <property name="text">
-                            <string>&lt;p&gt;This wizard will guide you through the steps that are necessary to create
-a new virtual machine for VirtualBox.&lt;/p&gt;
-&lt;p&gt;Use the &lt;b&gt;Next&lt;/b&gt; button to go the next page of the wizard
-and the &lt;b&gt;Back&lt;/b&gt; button to return to the previous page.&lt;/p&gt;</string>
-                        </property>
-                        <property name="alignment">
-                            <set>WordBreak|AlignTop</set>
-                        </property>
-                    </widget>
                     <spacer>
                         <property name="name">
@@ -188,26 +166,4 @@
                         <number>15</number>
                     </property>
-                    <widget class="QLabel">
-                        <property name="name">
-                            <cstring>txNameAndOS</cstring>
-                        </property>
-                        <property name="sizePolicy">
-                            <sizepolicy>
-                                <hsizetype>1</hsizetype>
-                                <vsizetype>0</vsizetype>
-                                <horstretch>0</horstretch>
-                                <verstretch>0</verstretch>
-                            </sizepolicy>
-                        </property>
-                        <property name="text">
-                            <string>&lt;p&gt;Enter a name for the new virtual machine and select the type of the guest operating
-system you plan to install onto the virtual machine.&lt;/p&gt;
-&lt;p&gt;The name of the virtual machine usually indicates its software and hardware configuration.
-It will be used by all VirtualBox components to identify your virtual machine.&lt;/p&gt;</string>
-                        </property>
-                        <property name="alignment">
-                            <set>WordBreak|AlignTop</set>
-                        </property>
-                    </widget>
                     <widget class="QGroupBox">
                         <property name="name">
@@ -428,42 +384,4 @@
                         <number>15</number>
                     </property>
-                    <widget class="QLabel">
-                        <property name="name">
-                            <cstring>textLabel1</cstring>
-                        </property>
-                        <property name="sizePolicy">
-                            <sizepolicy>
-                                <hsizetype>1</hsizetype>
-                                <vsizetype>0</vsizetype>
-                                <horstretch>0</horstretch>
-                                <verstretch>0</verstretch>
-                            </sizepolicy>
-                        </property>
-                        <property name="text">
-                            <string>&lt;p&gt;Select the amount of base memory (RAM) in megabytes to be allocated to the virtual machine.&lt;/p&gt;</string>
-                        </property>
-                        <property name="alignment">
-                            <set>WordBreak|AlignTop</set>
-                        </property>
-                    </widget>
-                    <widget class="QLabel">
-                        <property name="name">
-                            <cstring>txRAMBest2</cstring>
-                        </property>
-                        <property name="sizePolicy">
-                            <sizepolicy>
-                                <hsizetype>1</hsizetype>
-                                <vsizetype>0</vsizetype>
-                                <horstretch>0</horstretch>
-                                <verstretch>0</verstretch>
-                            </sizepolicy>
-                        </property>
-                        <property name="text">
-                            <string></string>
-                        </property>
-                        <property name="alignment">
-                            <set>WordBreak|AlignTop</set>
-                        </property>
-                    </widget>
                     <widget class="QGroupBox">
                         <property name="name">
@@ -747,48 +665,4 @@
                         <number>15</number>
                     </property>
-                    <widget class="QLabel">
-                        <property name="name">
-                            <cstring>textLabel1_3</cstring>
-                        </property>
-                        <property name="sizePolicy">
-                            <sizepolicy>
-                                <hsizetype>1</hsizetype>
-                                <vsizetype>0</vsizetype>
-                                <horstretch>0</horstretch>
-                                <verstretch>0</verstretch>
-                            </sizepolicy>
-                        </property>
-                        <property name="text">
-                            <string>&lt;p&gt;Select a hard disk image to be used
-as the boot hard disk of the virtual machine. You can either create a new hard
-disk using the &lt;b&gt;New&lt;/b&gt; button or select an existing hard disk
-image from the drop-down list or by pressing the &lt;b&gt;Existing&lt;/b&gt;
-button (to invoke the Virtual Disk Manager dialog).&lt;/p&gt;
-&lt;p&gt;If you need a more complicated hard disk setup, you can also skip this
-step and attach hard disks later using the VM Settings dialog.&lt;/p&gt;</string>
-                        </property>
-                        <property name="alignment">
-                            <set>WordBreak|AlignTop</set>
-                        </property>
-                    </widget>
-                    <widget class="QLabel">
-                        <property name="name">
-                            <cstring>txVDIBest</cstring>
-                        </property>
-                        <property name="sizePolicy">
-                            <sizepolicy>
-                                <hsizetype>1</hsizetype>
-                                <vsizetype>0</vsizetype>
-                                <horstretch>0</horstretch>
-                                <verstretch>0</verstretch>
-                            </sizepolicy>
-                        </property>
-                        <property name="text">
-                            <string></string>
-                        </property>
-                        <property name="alignment">
-                            <set>WordBreak|AlignTop</set>
-                        </property>
-                    </widget>
                     <widget class="QGroupBox">
                         <property name="name">
@@ -918,57 +792,4 @@
                         <number>15</number>
                     </property>
-                    <widget class="QLabel">
-                        <property name="name">
-                            <cstring>txSummaryHdr</cstring>
-                        </property>
-                        <property name="sizePolicy">
-                            <sizepolicy>
-                                <hsizetype>1</hsizetype>
-                                <vsizetype>0</vsizetype>
-                                <horstretch>0</horstretch>
-                                <verstretch>0</verstretch>
-                            </sizepolicy>
-                        </property>
-                        <property name="text">
-                            <string>
-                            &lt;p&gt;
-                            You are going to create a new virtual machine
-                            with the following parameters:
-                            &lt;/p&gt;
-                            </string>
-                        </property>
-                        <property name="alignment">
-                            <set>WordBreak|AlignTop</set>
-                        </property>
-                    </widget>
-                    <widget class="QLabel">
-                        <property name="name">
-                            <cstring>txSummaryFtr</cstring>
-                        </property>
-                        <property name="sizePolicy">
-                            <sizepolicy>
-                                <hsizetype>1</hsizetype>
-                                <vsizetype>0</vsizetype>
-                                <horstretch>0</horstretch>
-                                <verstretch>0</verstretch>
-                            </sizepolicy>
-                        </property>
-                        <property name="text">
-                            <string>
-                            &lt;p&gt;
-                            If the above is correct press the &lt;b&gt;Finish&lt;/b&gt; button.
-                            Once you press it, a new virtual machine will be created.
-                            &lt;/p&gt;&lt;p&gt;
-                            Note that you can alter these and all other setting of the
-                            created virtual machine at any time using the
-                            &lt;b&gt;Settings&lt;/b&gt; dialog accessible through
-                            the menu of the main window.
-                            &lt;/p&gt;
-                            </string>
-                        </property>
-                        <property name="alignment">
-                            <set>WordBreak|AlignTop</set>
-                        </property>
-                    </widget>
                     <spacer>
                         <property name="name">
@@ -1047,4 +868,5 @@
     <forward>class VBoxMediaComboBox</forward>
     <forward>class QITextEdit</forward>
+    <forward>class QILabel</forward>
 </forwards>
 <variables>
@@ -1057,4 +879,6 @@
     <variable access="private">VBoxMediaComboBox *mediaCombo;</variable>
     <variable access="private">QITextEdit *teSummary;</variable>
+    <variable access="private">QILabel *txRAMBest2;</variable>
+    <variable access="private">QILabel *txVDIBest;</variable>
 </variables>
 <slots>
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxNewVMWzd.ui.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxNewVMWzd.ui.h	(revision 2574)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxNewVMWzd.ui.h	(revision 2578)
@@ -55,4 +55,80 @@
 void VBoxNewVMWzd::init()
 {
+    /* Wizard labels recreation */
+
+    QILabel *txWelcome = new QILabel (pageWelcome, "txWelcome");
+    txWelcome->setText (tr ("<p>This wizard will guide you through the steps "
+                            "that are necessary to create\n""a new virtual "
+                            "machine for VirtualBox.</p>\n""<p>Use the "
+                            "<b>Next</b> button to go the next page of the "
+                            "wizard\n""and the <b>Back</b> button to return "
+                            "to the previous page.</p>"));
+    layout74->insertWidget (0, txWelcome);
+
+    QILabel *txNameAndOS = new QILabel (pageNameAndOS, "txNameAndOS");
+    txNameAndOS->setText (tr ("<p>Enter a name for the new virtual machine "
+                              "and select the type of the guest operating\n"
+                              "system you plan to install onto the virtual "
+                              "machine.</p>\n""<p>The name of the virtual "
+                              "machine usually indicates its software and "
+                              "hardware configuration.\n""It will be used by "
+                              "all VirtualBox components to identify your "
+                              "virtual machine.</p>"));
+    layout23->insertWidget (0, txNameAndOS);
+
+    QILabel *textLabel1 = new QILabel (pageMemory, "textLabel1");
+    textLabel1->setText (tr ("<p>Select the amount of base memory (RAM) in "
+                             "megabytes to be allocated to the virtual "
+                             "machine.</p>"));
+    layout35->insertWidget (0, textLabel1);
+
+    txRAMBest2 = new QILabel (pageMemory, "txRAMBest2");
+    layout35->insertWidget (1, txRAMBest2);
+
+    QILabel *textLabel1_3 = new QILabel (pageHDD, "textLabel1_3");
+    textLabel1_3->setText (tr ("<p>Select a hard disk image to be used\n"
+                               "as the boot hard disk of the virtual machine. "
+                               "You can either create a new hard\n""disk "
+                               "using the <b>New</b> button or select an "
+                               "existing hard disk\n""image from the "
+                               "drop-down list or by pressing the "
+                               "<b>Existing</b>\n""button (to invoke the "
+                               "Virtual Disk Manager dialog).</p>\n""<p>If "
+                               "you need a more complicated hard disk setup, "
+                               "you can also skip this\n""step and attach "
+                               "hard disks later using the VM Settings "
+                               "dialog.</p>"));
+    layout76->insertWidget (0, textLabel1_3);
+
+    txVDIBest = new QILabel (pageHDD, "txVDIBest");
+    layout76->insertWidget (1, txVDIBest);
+
+    QILabel *txSummaryHdr = new QILabel (pageSummary, "txSummaryHdr");
+    txSummaryHdr->setText (tr ("\n""                            <p>\n"
+                               "                            You are going "
+                               "to create a new virtual machine\n"
+                               "                            with the "
+                               "following parameters:\n"
+                               "                            </p>\n"
+                               "                            "));
+    summaryLayout->insertWidget (0, txSummaryHdr);
+
+    QILabel *txSummaryFtr = new QILabel (pageSummary, "txSummaryFtr");
+    txSummaryFtr->setText (tr ("\n""                            <p>\n"
+                               "                            If the above is "
+                               "correct press the <b>Finish</b> button.\n"
+                               "                            Once you press "
+                               "it, a new virtual machine will be created.\n"
+                               "                            </p><p>\n"
+                               "                            Note that you can "
+                               "alter these and all other setting of the\n"
+                               "                            created virtual "
+                               "machine at any time using the\n"
+                               "                            <b>Settings</b> "
+                               "dialog accessible through\n"
+                               "                            the menu of the "
+                               "main window.\n""                            "
+                               "</p>\n""                            "));
+
     /* disable help buttons */
     helpButton()->setShown (false);
@@ -127,4 +203,5 @@
     teSummary->setReadOnly (TRUE);
     summaryLayout->insertWidget (1, teSummary);
+    summaryLayout->insertWidget (2, txSummaryFtr);
 
     /* filter out Enter keys in order to direct them to the default dlg button */
@@ -179,15 +256,4 @@
     /* the finish button on the Summary page is always enabled */
     setFinishEnabled (pageSummary, true);
-
-    /* setup minimum width for the sizeHint to be calculated correctly */
-    int wid = widthSpacer->minimumSize().width();
-    txWelcome->setMinimumWidth (wid);
-    txNameAndOS->setMinimumWidth (wid);
-    textLabel1->setMinimumWidth (wid);
-    txRAMBest2->setMinimumWidth (wid);
-    textLabel1_3->setMinimumWidth (wid);
-    txVDIBest->setMinimumWidth (wid);
-    txSummaryHdr->setMinimumWidth (wid);
-    txSummaryFtr->setMinimumWidth (wid);
 }
 