Index: trunk/src/VBox/VMM/PDMDevice.cpp
===================================================================
--- trunk/src/VBox/VMM/PDMDevice.cpp	(revision 2611)
+++ trunk/src/VBox/VMM/PDMDevice.cpp	(revision 2623)
@@ -128,5 +128,5 @@
 static DECLCALLBACK(void) pdmR3DevHlp_STAMRegisterV(PPDMDEVINS pDevIns, void *pvSample, STAMTYPE enmType, STAMVISIBILITY enmVisibility, STAMUNIT enmUnit, const char *pszDesc, const char *pszName, va_list args);
 static DECLCALLBACK(int) pdmR3DevHlp_CritSectInit(PPDMDEVINS pDevIns, PPDMCRITSECT pCritSect, const char *pszName);
-static DECLCALLBACK(PRTTIMESPEC) pdmR3DevHlp_UCTNow(PPDMDEVINS pDevIns, PRTTIMESPEC pTime);
+static DECLCALLBACK(PRTTIMESPEC) pdmR3DevHlp_UTCNow(PPDMDEVINS pDevIns, PRTTIMESPEC pTime);
 
 static DECLCALLBACK(PVM) pdmR3DevHlp_GetVM(PPDMDEVINS pDevIns);
@@ -311,5 +311,5 @@
     pdmR3DevHlp_PDMQueueCreate,
     pdmR3DevHlp_CritSectInit,
-    pdmR3DevHlp_UCTNow,
+    pdmR3DevHlp_UTCNow,
     0,
     0,
@@ -396,5 +396,5 @@
     pdmR3DevHlp_PDMQueueCreate,
     pdmR3DevHlp_CritSectInit,
-    pdmR3DevHlp_UCTNow,
+    pdmR3DevHlp_UTCNow,
     0,
     0,
@@ -2337,14 +2337,14 @@
 
 
-/** @copydoc PDMDEVHLP::pfnUCTNow */
-static DECLCALLBACK(PRTTIMESPEC) pdmR3DevHlp_UCTNow(PPDMDEVINS pDevIns, PRTTIMESPEC pTime)
-{
-    PDMDEV_ASSERT_DEVINS(pDevIns);
-    LogFlow(("pdmR3DevHlp_UCTNow: caller='%s'/%d: pTime=%p\n", 
+/** @copydoc PDMDEVHLP::pfnUTCNow */
+static DECLCALLBACK(PRTTIMESPEC) pdmR3DevHlp_UTCNow(PPDMDEVINS pDevIns, PRTTIMESPEC pTime)
+{
+    PDMDEV_ASSERT_DEVINS(pDevIns);
+    LogFlow(("pdmR3DevHlp_UTCNow: caller='%s'/%d: pTime=%p\n", 
              pDevIns->pDevReg->szDeviceName, pDevIns->iInstance, pTime));
 
-    pTime = TMR3UCTNow(pDevIns->Internal.s.pVMHC, pTime);
-
-    LogFlow(("pdmR3DevHlp_UCTNow: caller='%s'/%d: returns %RU64\n", pDevIns->pDevReg->szDeviceName, pDevIns->iInstance, RTTimeSpecGetNano(pTime)));
+    pTime = TMR3UTCNow(pDevIns->Internal.s.pVMHC, pTime);
+
+    LogFlow(("pdmR3DevHlp_UTCNow: caller='%s'/%d: returns %RU64\n", pDevIns->pDevReg->szDeviceName, pDevIns->iInstance, RTTimeSpecGetNano(pTime)));
     return pTime;
 }
Index: trunk/src/VBox/VMM/TM.cpp
===================================================================
--- trunk/src/VBox/VMM/TM.cpp	(revision 2611)
+++ trunk/src/VBox/VMM/TM.cpp	(revision 2623)
@@ -358,12 +358,12 @@
 
     /*
-     * Configure real world time (UCT).
-     */
-    rc = CFGMR3QueryS64(pCfgHandle, "UCTOffset", &pVM->tm.s.offUCT);
+     * Configure real world time (UTC).
+     */
+    rc = CFGMR3QueryS64(pCfgHandle, "UTCOffset", &pVM->tm.s.offUTC);
     if (rc == VERR_CFGM_VALUE_NOT_FOUND)
-        pVM->tm.s.offUCT = 0; /* ns */
+        pVM->tm.s.offUTC = 0; /* ns */
     else if (VBOX_FAILURE(rc))
         return VMSetError(pVM, rc, RT_SRC_POS,
-                          N_("Configuration error: Failed to querying 64-bit integer value \"UCTOffset\". (%Vrc)"), rc);
+                          N_("Configuration error: Failed to querying 64-bit integer value \"UTCOffset\". (%Vrc)"), rc);
 
     /*
@@ -1739,5 +1739,5 @@
 
 /**
- * Get the real world UCT time adjusted for VM lag.
+ * Get the real world UTC time adjusted for VM lag.
  *
  * @returns pTime.
@@ -1745,9 +1745,9 @@
  * @param   pTime           Where to store the time.
  */
-TMR3DECL(PRTTIMESPEC) TMR3UCTNow(PVM pVM, PRTTIMESPEC pTime)
+TMR3DECL(PRTTIMESPEC) TMR3UTCNow(PVM pVM, PRTTIMESPEC pTime)
 {
     RTTimeNow(pTime);
     RTTimeSpecSubNano(pTime, pVM->tm.s.offVirtualSync - pVM->tm.s.offVirtualSyncGivenUp);
-    RTTimeSpecAddNano(pTime, pVM->tm.s.offUCT);
+    RTTimeSpecAddNano(pTime, pVM->tm.s.offUTC);
     return pTime;
 }
Index: trunk/src/VBox/VMM/TMInternal.h
===================================================================
--- trunk/src/VBox/VMM/TMInternal.h	(revision 2611)
+++ trunk/src/VBox/VMM/TMInternal.h	(revision 2623)
@@ -363,10 +363,10 @@
     }                           aVirtualSyncCatchUpPeriods[TM_MAX_CATCHUP_PERIODS];
 
-    /** The UCT offset in ns.
+    /** The UTC offset in ns.
      * This is *NOT* for converting UTC to local time. It is for converting real
-     * world UCT time to VM UCT time. This feature is indented for doing date
+     * world UTC time to VM UTC time. This feature is indented for doing date
      * testing of software and similar.
-     * @todo Implement warpdrive on UCT. */
-    int64_t                     offUCT;
+     * @todo Implement warpdrive on UTC. */
+    int64_t                     offUTC;
 
     /** Timer queues for the different clock types - R3 Ptr */