Index: trunk/src/VBox/Additions/linux/sharedfolders/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/linux/sharedfolders/Makefile.kmk	(revision 2614)
+++ trunk/src/VBox/Additions/linux/sharedfolders/Makefile.kmk	(revision 2639)
@@ -30,66 +30,18 @@
 
 #
+# Populate FILES_VBOXVFS_NOBIN and FILES_VBOXVFS_BIN
+#
+include files_vboxvfs
+
+#
 # Install the source.
 #
 vboxvfs-bin_INST        = bin/additions/src/vboxvfs
 vboxvfs-bin_MODE        = a+r,u+w
-vboxvfs-bin_SOURCES     = \
-	$(PATH_ROOT)/include/iprt/alloc.h=>include/iprt/alloc.h \
-	$(PATH_ROOT)/include/iprt/asm.h=>include/iprt/asm.h \
-	$(PATH_ROOT)/include/iprt/assert.h=>include/iprt/assert.h \
-	$(PATH_ROOT)/include/iprt/cdefs.h=>include/iprt/cdefs.h \
-	$(PATH_ROOT)/include/iprt/err.h=>include/iprt/err.h \
-	$(PATH_ROOT)/include/iprt/fs.h=>include/iprt/fs.h \
-	$(PATH_ROOT)/include/iprt/log.h=>include/iprt/log.h \
-	$(PATH_ROOT)/include/iprt/mem.h=>include/iprt/mem.h \
-	$(PATH_ROOT)/include/iprt/param.h=>include/iprt/param.h \
-	$(PATH_ROOT)/include/iprt/path.h=>include/iprt/path.h \
-	$(PATH_ROOT)/include/iprt/semaphore.h=>include/iprt/semaphore.h \
-	$(PATH_ROOT)/include/iprt/stdarg.h=>include/iprt/stdarg.h \
-	$(PATH_ROOT)/include/iprt/stdint.h=>include/iprt/stdint.h \
-	$(PATH_ROOT)/include/iprt/string.h=>include/iprt/string.h \
-	$(PATH_ROOT)/include/iprt/time.h=>include/iprt/time.h \
-	$(PATH_ROOT)/include/iprt/types.h=>include/iprt/types.h \
-	$(PATH_ROOT)/include/VBox/cdefs.h=>include/VBox/cdefs.h \
-	$(PATH_ROOT)/include/VBox/err.h=>include/VBox/err.h \
-	$(PATH_ROOT)/include/VBox/hgcmsvc.h=>include/VBox/hgcmsvc.h \
-	$(PATH_ROOT)/include/VBox/log.h=>include/VBox/log.h \
-	$(PATH_ROOT)/include/VBox/ostypes.h=>include/VBox/ostypes.h \
-	$(PATH_ROOT)/include/VBox/shflsvc.h=>include/VBox/shflsvc.h \
-	$(PATH_ROOT)/include/VBox/types.h=>include/VBox/types.h \
-	$(PATH_ROOT)/include/VBox/VBoxGuest.h=>include/VBox/VBoxGuest.h \
-	$(PATH_ROOT)/include/VBox/VBoxGuestLib.h=>include/VBox/VBoxGuestLib.h \
-	$(PATH_ROOT)/src/VBox/Additions/common/VBoxGuestLib/GenericRequest.cpp=>GenericRequest.c \
-	$(PATH_ROOT)/src/VBox/Additions/common/VBoxGuestLib/HGCM.cpp=>HGCM.c \
-	$(PATH_ROOT)/src/VBox/Additions/common/VBoxGuestLib/Init.cpp=>Init.c \
-	$(PATH_ROOT)/src/VBox/Additions/common/VBoxGuestLib/PhysHeap.cpp=>PhysHeap.c \
-	$(PATH_ROOT)/src/VBox/Additions/common/VBoxGuestLib/SysHlp.cpp=>SysHlp.c \
-	$(PATH_ROOT)/src/VBox/Additions/common/VBoxGuestLib/SysHlp.h=>SysHlp.h \
-	$(PATH_ROOT)/src/VBox/Additions/common/VBoxGuestLib/VBGLInternal.h=>VBGLInternal.h \
-	$(PATH_ROOT)/src/VBox/Additions/common/VBoxGuestLib/VBoxCalls.c=>VBoxCalls.c \
-	$(PATH_ROOT)/src/VBox/Additions/common/VBoxGuestLib/VBoxCalls.h=>VBoxCalls.h \
-	$(PATH_ROOT)/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestLog.h=>VBoxGuestLog.h \
-	$(PATH_ROOT)/src/VBox/Additions/common/VBoxGuestLib/VMMDev.cpp=>VMMDev.c \
-	$(PATH_ROOT)/src/VBox/Runtime/include/internal/magics.h=>include/internal/magics.h \
-	$(PATH_ROOT)/src/VBox/Runtime/r0drv/alloc-r0drv.cpp=>r0drv/alloc-r0drv.c \
-	$(PATH_ROOT)/src/VBox/Runtime/r0drv/alloc-r0drv.h=>r0drv/alloc-r0drv.h \
-	$(PATH_ROOT)/src/VBox/Runtime/r0drv/linux/alloc-r0drv-linux.c=>r0drv/linux/alloc-r0drv-linux.c \
-	$(PATH_ROOT)/src/VBox/Runtime/r0drv/linux/semaphore-r0drv-linux.c=>r0drv/linux/semaphore-r0drv-linux.c \
-	$(PATH_ROOT)/src/VBox/Runtime/r0drv/linux/string.h=>r0drv/linux/string.h \
-	$(PATH_ROOT)/src/VBox/Runtime/r0drv/linux/the-linux-kernel.h=>r0drv/linux/the-linux-kernel.h \
-	$(PATH_OUT)/version-generated.h=>version-generated.h \
-	Makefile.module=>Makefile \
-	dirops.c=>dirops.c \
-	regops.c=>regops.c \
-	utils.c=>utils.c \
-	vfs-utils.c=>vfs-utils.c \
-	vbsfmount.h=>vbsfmount.h \
-	vfsmod.c=>vfsmod.c \
-	vfsmod.h=>vfsmod.h
+vboxvfs-bin_SOURCES     = $(subst ",,$(FILES_VBOXVFS_NOBIN))
 
-vboxvfs-sh_INST        = bin/additions/src/vboxvfs
-vboxvfs-sh_MODE        = a+rx,u+w
-vboxvfs-sh_SOURCES     = \
-	$(PATH_ROOT)/src/VBox/HostDrivers/Support/linux/build_in_tmp=>build_in_tmp
+vboxvfs-sh_INST         = bin/additions/src/vboxvfs
+vboxvfs-sh_MODE         = a+rx,u+w
+vboxvfs-sh_SOURCES      = $(subst ",,$(FILES_VBOXVFS_BIN))
 
 #
Index: trunk/src/VBox/Additions/linux/sharedfolders/Makefile.module
===================================================================
--- trunk/src/VBox/Additions/linux/sharedfolders/Makefile.module	(revision 2614)
+++ trunk/src/VBox/Additions/linux/sharedfolders/Makefile.module	(revision 2639)
@@ -163,3 +163,3 @@
 clean:
 	for f in . linux r0drv r0drv/linux; do rm -f $$f/*.o $$f/.*.cmd $$f/.*.flags; done
-	rm -rf .vboxdrv* .tmp_ver* vboxdrv.* Module.symvers Modules.symvers
+	rm -rf .vboxvfs* .tmp_ver* vboxvfs.* Module.symvers Modules.symvers